<!--
  ~ EVS Client is part of the Gazelle Test Bed
  ~ Copyright (C) 2006-2016 IHE
  ~ mailto :eric DOT poiseau AT inria DOT fr
  ~
  ~ See the NOTICE file distributed with this work for additional information
  ~ regarding copyright ownership.  This code is licensed
  ~ to you under the Apache License, Version 2.0 (the
  ~ "License"); you may not use this file except in compliance
  ~ with the License.  You may obtain a copy of the License at
  ~
  ~   http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing,
  ~ software distributed under the License is distributed on an
  ~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~ KIND, either express or implied.  See the License for the
  ~ specific language governing permissions and limitations
  ~ under the License.
  -->
<ui:composition xmlns:h="http://java.sun.com/jsf/html" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:g="http://www.ihe.net/gazelle" xmlns:f="http://java.sun.com/jsf/core" xmlns:c="http://java.sun.com/jstl/core"
                xmlns:rich="http://richfaces.org/rich" xmlns:gdk="http://www.ihe.net/gazellecdk"
                xmlns:a4j="http://richfaces.org/a4j" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns="http://www.w3.org/1999/xhtml" template="//layout/template.xhtml">
    <ui:param name="pageName" value="#{messages['gazelle.common.menu.MenuStatistics']}"/>
    <ui:param name="pageNameUrl" value="/administration/statisticsByType.seam"/>
    <ui:param name="pageNameTitle"
              value="#{messages['net.ihe.gazelle.evs.StatisticsFor']} #{statisticsByStandardBeanGui.getStandardName()}"/>
    <ui:define name="body">
        <script type="text/javascript" src="https://www.google.com/jsapi"/>
        <script type="text/javascript">
            google.load("visualization", "1", {packages:["corechart"]});
            google.setOnLoadCallback(drawAllCharts);

            function drawAllCharts()
            {
                drawColumnForValidator();
                drawColumnChartForServices();
                drawPieChart();
                drawTimeLineMonth();
                drawTimeLineYear();
            }

            function drawColumnForValidator() {
                var data = new google.visualization.DataTable();
                data.addColumn('string', '#{messages['net.ihe.gazelle.evs.Validator']}');
                data.addColumn('number', 'Validations requests');
                data.addRows([
                    <ui:repeat value="#{statisticsByStandardBeanGui.getStatisticsPerValidator()}" var="stat">
                        ['#{stat[0]}',  #{stat[1]}],
                    </ui:repeat>
                ]);

                var options = {
                    hAxis: {title: '#{messages['net.ihe.gazelle.evs.Validator']}',
                        textStyle: {fontSize:9},
                        slantedText: true,
                        slantedTextAngle: 45,
                        allowContainerBoundaryTextCufoff: true},
                    vAxis: {title: 'Number of validation requests',
                        allowContainerBoundaryTextCufoff: true}
                };

                var chart = new google.visualization.ColumnChart(document.getElementById('columnDiv'));
                chart.draw(data, options);
            }

            function drawColumnChartForServices() {
                var data = new google.visualization.DataTable();
                data.addColumn('string', '#{messages['net.ihe.gazelle.evs.ValidationService']}');
                data.addColumn('number', 'Validations requests');
                data.addRows([
                    <ui:repeat value="#{statisticsByStandardBeanGui.getStatisticsPerValidationService()}" var="stat">
                        ['#{stat[0]}',  #{stat[1]}],
                    </ui:repeat>
                ]);

            var options = {
                hAxis: {title: '#{messages['net.ihe.gazelle.evs.ValidationService']}',
                    textStyle: {fontSize:9},
                    slantedText: true,
                    slantedTextAngle: 45,
                    allowContainerBoundaryTextCufoff: false},
                vAxis: {title: 'Number of validation requests'}
            };

            var chartService = new google.visualization.ColumnChart(document.getElementById('servicesDiv'));
            chartService.draw(data, options);

            }

            function drawPieChart() {
                var data = new google.visualization.DataTable();
                data.addColumn('string', 'Status');
                data.addColumn('number', 'percentage');
                data.addRows([
                    <ui:repeat value="#{statisticsByStandardBeanGui.getStatisticsPerStatus()}" var="stat">
                        ['#{stat[0]}',  #{stat[1]}],
                    </ui:repeat>
                ]);

                var options = {
                    slices: {0: {color: 'green'}, 1: {color: 'red'}, 2: {color: 'orange'}}
                };

                var chartPie = new google.visualization.PieChart(document.getElementById('repartitionDiv'));
                chartPie.draw(data, options);

            }

            function drawTimeLineMonth(){
                var data = new google.visualization.DataTable();
                data.addColumn('string', 'Period');
                data.addColumn('number', 'Number of validations');
                data.addRows([
                    <ui:repeat value="#{statisticsByStandardBeanGui.countPerDateMonthIntervalByReferencedStandardId()}" var="stat">
                        ['#{stat[0]}',  #{stat[1]}],
                    </ui:repeat>
                ]);

                var options = {
                    hAxis: {title: 'Period of time (months)', textStyle: {fontSize:9}},
                    vAxis: {title: 'Number of validation requests'},
                    pointSize: 3
                };
                var chartMonthr = new google.visualization.LineChart(document.getElementById('timeline_month'));
                chartMonthr.draw(data, options);
            }

            function drawTimeLineYear(){
                var data = new google.visualization.DataTable();
                data.addColumn('string', 'Period');
                data.addColumn('number', 'Number of validations');
                data.addRows([
                    <ui:repeat value="#{statisticsByStandardBeanGui.countPerDateYearIntervalByReferencedStandardId()}" var="stat">
                        ['#{stat[0]}',  #{stat[1]}],
                    </ui:repeat>
                ]);

                var options = {
                    hAxis: {title: 'Period of time (years)',
                        textStyle: {fontSize:9},
                        allowContainerBoundaryTextCufoff: true,
                    },
                    vAxis: {title: 'Number of validation requests',
                        allowContainerBoundaryTextCufoff: true},
                    pointSize: 3
                };
                var chartYear = new google.visualization.LineChart(document.getElementById('timeline_year'));
                chartYear.draw(data, options);
            }
        </script>

        <s:div id="globalDiv">

            <h:form id="globalform">


                <s:div id="links">
                    <ui:decorate template="/layout/panels/_panel_title.xhtml">


                        <ui:define name="panel_title">
                            <h:outputText value="#{messages['net.ihe.gazelle.evs.Links']}"/>
                        </ui:define>
                        <ul>
                            <li>
                                <a href="#columnchart">#{messages['net.ihe.gazelle.evs.NumberOfValidationPerValidationServices']}</a>
                            </li>
                            <li>
                                <a href="#columnchart1">#{messages['net.ihe.gazelle.evs.NumberOfValidationPerValidationContext']}</a>
                            </li>
                            <li>
                                <a href="#piechart">#{messages['net.ihe.gazelle.evs.RepartitionOfValidationOutcomes']}</a>
                            </li>
                            <li>
                                <a href="#timelinemonth">#{messages['net.ihe.gazelle.evs.TimelineamountOfValidationRequestsPerMonths']})</a>
                            </li>
                            <li>
                                <a href="#timelineyear">#{messages['net.ihe.gazelle.evs.TimelineamountOfValidationRequestsPerYear']})</a>
                            </li>
                        </ul>
                    </ui:decorate>
                </s:div>

                <ui:decorate template="/layout/panels/_panel_title.xhtml">


                    <ui:define name="panel_title">
                        <h:outputText value="#{messages['net.ihe.gazelle.evs.NumberOfValidationPerValidationServices']}"/>
                    </ui:define>

                    <a name="columnchart"/>
                    <div id="servicesDiv" style="width: 900px; height: 500px;"/>
                </ui:decorate>

                <ui:decorate template="/layout/panels/_panel_title.xhtml">


                    <ui:define name="panel_title">
                        <h:outputText value="#{messages['net.ihe.gazelle.evs.NumberOfValidationPerValidationContext']}"/>
                    </ui:define>
                    <a name="columnchart1"/>
                    <div id="columnDiv" style="height: 500px;"/>
                </ui:decorate>


                <ui:decorate template="/layout/panels/_panel_title.xhtml">


                    <ui:define name="panel_title">
                        <h:outputText value="#{messages['net.ihe.gazelle.evs.RepartitionOfValidationOutcomes']}"/>
                    </ui:define>
                    <a name="piechart"/>
                    <div id="repartitionDiv" style="width: 900px; height: 500px;"/>
                </ui:decorate>

                <ui:decorate template="/layout/panels/_panel_title.xhtml">


                    <ui:define name="panel_title">
                        <h:outputText value="#{messages['net.ihe.gazelle.evs.TimelineamountOfValidationRequestsPerMonths']})"/>
                    </ui:define>
                    <a name="timelinemonth"/>
                    <div id="timeline_month" style="height: 500px;"/>
                </ui:decorate>

                <ui:decorate template="/layout/panels/_panel_title.xhtml">
                    <ui:define name="panel_title">
                        <h:outputText value="#{messages['net.ihe.gazelle.evs.TimelineamountOfValidationRequestsPerYear']})"/>
                    </ui:define>
                    <a name="timelineyear"/>
                    <div id="timeline_year" style="height: 500px;"/>
                </ui:decorate>
            </h:form>

        </s:div>
    </ui:define>
</ui:composition>
